package runnergenerator

import (
	"fmt"
	util "l1-hlt-prescales-toolkit/internal/generators/util"
	"os"
	"path"
	"strings"
	"text/template"
	"time"
)

// GenerateAll the script runners in /src/scriptrunner/external
func GenerateAll() {
	externals, err := util.GetExternals()
	if err != nil {
		panic(err)
	}

	for _, external := range externals {
		GenerateScriptrunner(external)
	}
}

// GenerateScriptrunner generates a script runner for a given package name
func GenerateScriptrunner(name util.ExternalPackage) {
	config, err := util.ReadConfig(name)
	if err != nil {
		panic(err)
	}

	cwd, err := os.Getwd()
	if err != nil {
		panic(err)
	}

	fileName := "../../scriptrunner/external/generated_" + string(name) + ".go"
	fullPath := path.Join(cwd, fileName)

	if config.Stub {
		fmt.Println("skipping", fullPath)
		return
	}
	fmt.Println("generating", fullPath)

	f, err := os.Create(fullPath)
	if err != nil {
		panic(err)
	}
	defer f.Close()

	runPieces := strings.Split(config.Run, " ")
	runArgs := make([]string, 0)
	if len(runPieces) > 1 {
		runArgs = runPieces[1:]
	}

	err = scriptrunnerTemplate.Execute(f, templateData{
		Timestamp:      time.Now(),
		Config:         config,
		TemplatedFlags: util.ExtendFlags(config.Flags),
		RunBin:         runPieces[0],
		RunArgs:        runArgs,
		Folder:         name,
	})
	if err != nil {
		panic(err)
	}
}

type templateData struct {
	Folder         util.ExternalPackage
	Timestamp      time.Time
	Config         *util.ExternalConfig
	TemplatedFlags []util.ExtendedFlag
	RunBin         string
	RunArgs        []string
}

var scriptrunnerTemplate = template.Must(template.New("").Funcs(template.FuncMap{
	"makeStringArray": util.TemplateStringArray,
	"capitalize":      util.Capitalize,
	"noSpaces":        util.NoSpaces,
}).Parse(`// Code generated by go generate; DO NOT EDIT.
// This file was generated by robots at {{ .Timestamp }}
package external

import (
	"l1-hlt-prescales-toolkit/internal/scriptrunner"
	"github.com/sirupsen/logrus"
	"strings"
)

// {{ noSpaces (capitalize .Config.Command) }}
{{- if .Config.Long }} {{ .Config.Long }}
{{- else if .Config.Short }} {{ .Config.Short }}
{{- else }} runs the external package '{{ .Config.Command }}'
{{- end }}
func {{ noSpaces (capitalize .Config.Command) }}(
{{- range $i, $arg := .Config.Args -}}
{{- if $i }}, {{ end -}}
{{ noSpaces $arg.Name }} string
{{- end -}}
{{- range $i, $flag := .TemplatedFlags -}}
{{- if $i }}, {{ else if len $.Config.Args }}, {{ end -}}
{{ $flag.Name }} {{ $flag.GoType }}
{{- end -}}
) (
	stdout chan string,
	stderr chan string,
	fd3 chan string,
	done chan error,
) {
	arg := {{ makeStringArray .RunArgs }}
	{{- range $flag := .TemplatedFlags }}
	{{- if eq $flag.GoType "bool" }}
	if {{ $flag.Name }} {
		arg = append(arg, "--{{ $flag.Name }}")
	}
	{{- else }}
	if {{ $flag.Name }} != "" {
		arg = append(arg, "--{{ $flag.Name }}", {{ $flag.Name }})
	}
	{{- end }}
	{{- end }}

	{{- range $arg := .Config.Args }}
	arg = append(arg, {{ noSpaces $arg.Name }})
	{{- end }}

	job := scriptrunner.NewJob(scriptrunner.GetPackageDir("{{ .Folder }}"), "{{ .RunBin }}", arg, nil)
	log.WithFields(logrus.Fields{"dir": job.Dir, "command": job.ScriptPath, "args": strings.Join(job.Arg, " ")}).Info("running command")
	stdout, stderr, fd3, done = job.RunAsync()
	return
}
`))
